/* $Header: /usr2/brugere/jbln/uc133/src/RCS/uc.h,v 1.4 1995/03/06 23:18:47 jbln Exp jbln $ */

#define VERSION 140

#include "memdebug.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#ifdef ULTRIX
#include <cursesX.h>
#elif LINUXN
#include <ncurses/ncurses.h>
#else
#include <curses.h>
#endif

#include "../make.cfg"

/* Lets hope this works ... */
#ifndef SEEK_SET
#define SEEK_SET 0
#endif

#define UCNAMESIZE 200
#define UCPATHSIZE 200
#define FALLOCSIZE 200

#define SHOWNORM 0
#define SHOWWIDE 1
#define SHOWTREE 2

#define FMODE_LINK 0120000
#define FMODE_NORM 0100000
#define FMODE_SPEC 0070000
#define FMODE_BLCK 0060000
#define FMODE_DIR  0040000
#define FMODE_CHAR 0020000
#define FMODE_FIFO 0010000
#define FMODE_EXEC 0000111
#define FTYPE_DIR 0
#define FTYPE_NORM 1
#define FTYPE_DEV 2
#define FTYPE_LINK 3
#define FTYPE_FIFO 4
#define FTYPE_OTHER 5

#define SORT_NAME 0
#define SORT_SIZE 1
#define SORT_EXT 2
#define SORT_DATE 3
#define SORT_NONE 10


typedef struct 
{
   int up;
   int down;
   int left;
   int right;
   int enter;
   int pageup;
   int pagedown;
   int backspace;
} TERMINFO;

typedef struct
{
   char *mask;
   char *command;
} ASSOC;

typedef struct
{
   char *descr;
   char *path;
   int level;
} TREEINFO;

typedef struct
{
   char *name;
   long size;
   int type;
   int mode;
   int linknum;
   char islink;
   int pos;
   unsigned int uid;
   unsigned int gid;
   char mark;
   char grpname[20];
   char usrname[20];
   struct tm fdate;
   time_t filetime;
   TREEINFO tree;
} FILEINFO;

typedef struct
{
   char path[UCNAMESIZE];
   char spath[UCNAMESIZE];
   FILEINFO *files;
   int filenum;
   int allocnum;
   int pos, oldpos;
   int offset, oldoffset;
   char enabled;
   int showmode;
   int size;
   int sorting;
   int grpcou;
   unsigned long grpsize;
   int dirmode;
   int showhidden;
   int treelevel;
} FILESPEC;


extern FILESPEC uc[2];


#define CONFIGNUM 20
extern char *configvals[CONFIGNUM];



/* ===== FILE ASSOCIATION  &  ALIASES ==================== */

extern ASSOC *fassoc;
extern int assoc_num;

extern ASSOC *diralias;
extern int daliasnum;

/* ===== TERMINAL INFORMATION ============================ */
#define TERMKEYNUM 8
extern TERMINFO terminal;
extern char *termnames[TERMKEYNUM];
extern char *configvals[CONFIGNUM];


/* ===== SCREEN SETUP ==================================== */
#define SCREENNUM 4
extern char *screennames[SCREENNUM];


/* ===== PREFERENCES  ==================================== */
#define PREFNUM 4
#define PREFEDITOR 0
#define PREFVIEWER 1
#define PREFSAVEHIST 2
#define PREFSHELL 3
extern char *prefvals[PREFNUM];
extern char *prefnames[PREFNUM];


/* ===== USERKEYS ======================================== */
#define UKNUM 28
extern char *userkeys[UKNUM];

extern int errno;
extern char *sys_errlist[];
extern int sys_nerr;


/* ===== USERKEYS ======================================== */
#define HISTORY (DEF_HISTORY+1)
extern char command_stack[HISTORY][201];
extern int cstack_front;
extern int cstack_back;
extern int cstack_cur;


extern char *ftype_names[4];

#define GETINFO(n) uc[n].files[uc[n].pos+uc[n].offset]
#define RETONTREE(pos) if (uc[(pos)].showmode==SHOWTREE) return(0)

/*
#ifdef strdup
#undef strdup
#endif

#define strdup(x) uc_strdup((x)) 
*/
char *uc_strdup();
char *assoc_macro();
int sort_byname();
char *get_cur_dir();

#define N(pos) ((pos)==0 ? 1 : 0)
